
<template>
  <div class='tabviewpanel' style="height:100%;">
        <tabs :value="activiedTabViewPanel" :animated="false" class='tabexppanel' name='stabexpviewtabexppanel' @on-click="tabPanelClick">
        <tab-pane :index="0" name='tabviewpanel' tab='stabexpviewtabexppanel' class=''  v-if="authResourceObject['tabviewpanel'].visabled"
            :label="(h) =>{
                return h('div', [
                    h('span', '统一产品'),
                    h('Badge', {
                        props: {
                            count: undefined,
                            type: 'primary'
                        }
                    })
                ])
            }" >
            <view_tabviewpanel 
    :viewState="viewState"  
    :viewparams="JSON.parse(JSON.stringify(viewparams))" 
    :context="JSON.parse(JSON.stringify(context))" 
    v-if="isInit.tabviewpanel"
    name="tabviewpanel"  
    ref='tabviewpanel'
    @viewpanelDatasChange = "tabViewPanelDatasChange"
    @closeview="closeView($event)">
</view_tabviewpanel>
        </tab-pane>
        <tab-pane :index="1" name='tabviewpanel3' tab='stabexpviewtabexppanel' class=''  v-if="authResourceObject['tabviewpanel3'].visabled"
            :label="(h) =>{
                return h('div', [
                    h('span', '软件'),
                    h('Badge', {
                        props: {
                            count: undefined,
                            type: 'primary'
                        }
                    })
                ])
            }" >
            <view_tabviewpanel3 
    :viewState="viewState"  
    :viewparams="JSON.parse(JSON.stringify(viewparams))" 
    :context="JSON.parse(JSON.stringify(context))" 
    v-if="isInit.tabviewpanel3"
    name="tabviewpanel3"  
    ref='tabviewpanel3'
    @viewpanelDatasChange = "tabViewPanelDatasChange"
    @closeview="closeView($event)">
</view_tabviewpanel3>
        </tab-pane>
        <tab-pane :index="2" name='tabviewpanel2' tab='stabexpviewtabexppanel' class=''  v-if="authResourceObject['tabviewpanel2'].visabled"
            :label="(h) =>{
                return h('div', [
                    h('span', '硬件'),
                    h('Badge', {
                        props: {
                            count: undefined,
                            type: 'primary'
                        }
                    })
                ])
            }" >
            <view_tabviewpanel2 
    :viewState="viewState"  
    :viewparams="JSON.parse(JSON.stringify(viewparams))" 
    :context="JSON.parse(JSON.stringify(context))" 
    v-if="isInit.tabviewpanel2"
    name="tabviewpanel2"  
    ref='tabviewpanel2'
    @viewpanelDatasChange = "tabViewPanelDatasChange"
    @closeview="closeView($event)">
</view_tabviewpanel2>
        </tab-pane>
    </tabs>
  </div>
</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZSample0003Service from '@/service/ibizsample0003/ibizsample0003-service';
import STabExpViewtabexppanelService from './stab-exp-viewtabexppanel-tabexppanel-service';
import IBIZSample0003UIService from '@/uiservice/ibizsample0003/ibizsample0003-ui-service';
import IBIZSample0003AuthService from '@/authservice/ibizsample0003/ibizsample0003-auth-service';
import { Environment } from '@/environments/environment';


@Component({
    components: {
      
    }
})
export default class STabExpViewtabexppanelBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof STabExpViewtabexppanelBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof STabExpViewtabexppanelBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof STabExpViewtabexppanelBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof STabExpViewtabexppanelBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof STabExpViewtabexppanelBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof STabExpViewtabexppanelBase
     */
    public getControlType(): string {
        return 'TABEXPPANEL'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof STabExpViewtabexppanelBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {STabExpViewtabexppanelService}
     * @memberof STabExpViewtabexppanelBase
     */
    public service: STabExpViewtabexppanelService = new STabExpViewtabexppanelService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZSample0003Service}
     * @memberof STabExpViewtabexppanelBase
     */
    public appEntityService: IBIZSample0003Service = new IBIZSample0003Service({ $store: this.$store });
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  STabExpViewtabexppanelBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof STabExpViewtabexppanelBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    /**
     * 实体权限服务对象
     *
     * @type {IBIZSample0003AuthService}
     * @memberof TabExpViewtabexppanelBase
     */
    public appAuthService: IBIZSample0003AuthService = new IBIZSample0003AuthService();

    /**
     * 界面UI服务对象
     *
     * @type {IBIZSample0003UIService}
     * @memberof STabExpViewtabexppanelBase
     */  
    public appUIService:IBIZSample0003UIService = new IBIZSample0003UIService(this.$store);

    /**
     * 是否初始化
     *
     * @returns {any}
     * @memberof STabExpViewtabexppanelBase
     */
    public isInit: any = {
        tabviewpanel:  true ,
        tabviewpanel3:  false ,
        tabviewpanel2:  false ,
    }

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof STabExpViewtabexppanelBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof STabExpViewtabexppanelBase
     */
    public getData(): any {
        return null;
    }

    /**
     * 从父传入的当前分页面板panel值
     *
     * @type {string}
     * @memberof STabExpViewtabexppanelBase
     */
    @Prop() public tabValue?: string;

    /**
     * 值变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof STabExpViewtabexppanelBase
     */
    @Watch('tabValue')
    public onValueChange(newVal: any, oldVal: any) {
        this.tabPanelClick(newVal);
    }

    /**
     * 行为参数
     *
     * @public
     * @type {*}
     * @memberof STabExpViewtabexppanelBase
     */
    public action:any = '';

    /**
     * 分页面板权限标识存储对象
     *
     * @public
     * @type {*}
     * @memberof STabExpViewtabexppanelBase
     */
    public authResourceObject:any = {'tabviewpanel':{resourcetag:null,visabled: true,disabled: false},'tabviewpanel3':{resourcetag:null,visabled: true,disabled: false},'tabviewpanel2':{resourcetag:null,visabled: true,disabled: false}};

    /**
     * 被激活的分页面板
     *
     * @type {string}
     * @memberof STabExpViewtabexppanelBase
     */
    public activiedTabViewPanel: string = 'tabviewpanel';

    /**
     * 计算分页面板权限
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public computedAuthPanel(data:any){
        if(!data || Object.keys(data).length === 0){
            return;
        }
        if(this.authResourceObject && Object.keys(this.authResourceObject).length >0){
            Object.keys(this.authResourceObject).forEach((key:string) =>{
                if(this.authResourceObject[key] && this.authResourceObject[key]['dataaccaction']){
                    let tempUIAction:any = Util.deepCopy(this.authResourceObject[key]);
                    let result: any[] = ViewTool.calcActionItemAuthState(data,[tempUIAction],this.appUIService);
                    this.authResourceObject[key].visabled = this.computedPanelWithResource(key,tempUIAction.visabled);
                    this.authResourceObject[key].disabled = this.computedPanelWithResource(key,tempUIAction.disabled);
                }
            })
            const keys:any = Object.keys(this.authResourceObject);
            for(let i=0;i<keys.length;i++){
                if(this.authResourceObject[keys[i]].visabled){
                    this.tabPanelClick(keys[i]);
                    return;
                }
            }
        }
    }

    /**
     * 合入统一资源权限
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public computedPanelWithResource(name:string,mainState:boolean){
        if(!this.$store.getters['authresource/getEnablePermissionValid'])
            return mainState === false?false:true;
        if(!this.authResourceObject[name]) 
            return mainState === false?false:true;
        const resourceAuth:boolean = this.appAuthService.getResourcePermission(this.authResourceObject[name]['resourcetag']);
        return !resourceAuth?false:mainState?true:false;
    }

    /**
     * 分页视图面板数据变更
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public tabViewPanelDatasChange(){
        this.counterRefresh();
    }

    /**
     * vue 生命周期
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof STabExpViewtabexppanelBase
     */    
    public afterCreated(){
        //设置分页导航srfparentdename和srfparentkey
        if(this.context.ibizsample0003){
            Object.assign(this.context,{srfparentdename:'IBIZSample0003',srfparentkey:this.context.ibizsample0003})
        }
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if(Object.is(action,'loadmodel')){
                    this.computedAuthPanel(data);
                }else{
                    this.action = action;
                    this.viewState.next({ tag: this.activiedTabViewPanel, action: action, data: data });
                    this.$forceUpdate();
                }
            });
        }
    }    

    /**
     * vue 生命周期
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof STabExpViewtabexppanelBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
     * 分页面板选中
     *
     * @param {*} $event
     * @returns
     * @memberof STabExpViewtabexppanelBase
     */
    public tabPanelClick($event: any) {
        if (!$event) {
            return;
        }
        this.isInit = [];
        this.isInit[$event] = true;
        if (!this.viewState) {
            return;
        }
        this.activiedTabViewPanel = $event;
        this.viewState.next({ tag: this.activiedTabViewPanel, action: this.action, data: {}});
    }



}
</script>

<style lang='less'>
@import './stab-exp-viewtabexppanel-tabexppanel.less';
</style>